Bug 33512 - mod_mem_cache and possibly mod_deflate
Summary: mod_mem_cache and possibly mod_deflate
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_cache (show other bugs)
Version: 2.0.53
Hardware: PC Linux
: P2 major (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL: http://www.awmach.org
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2005-02-11 05:19 UTC by William H. Haller
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description William H. Haller 2005-02-11 05:19:22 UTC
2.0.53 fails to properly cache fixed text type pages. Caching of images/gifs
seems to be OK, but normal text is failing which makes me wonder if there isn't
a deflate interaction. The end result is that the header is garbled or is
missing when sent to the browser resulting in raw HTML output. This has also
been noticed with the delivery of stylesheets. I have reverted back to 2.0.52 at
work and disabled caching for everything but gifs at home.

Configuration information available upon request.
Comment 1 Joe Orton 2005-02-25 18:07:50 UTC
Please do provide those config details.
Comment 2 William H. Haller 2005-02-26 01:06:13 UTC
Linux FC3 fully patched

Apache configure:
CFLAGS="-O2 -march=pentium3 -mcpu=pentium3" \
./configure -prefix=/usr/local/apache2 --enable-modules="all" --with-mpm=worker \
--disable-auth-anon \
--disable-auth-dbm \
--disable-file-cache \
--enable-cache \
--enable-disk-cache \
--enable-mem-cache \
--enable-deflate \
--enable-rewrite \
--disable-cern-meta \
--disable-expires \
--disable-headers \
--disable-usertrack \
--disable-unique-id \
--enable-ssl \
--with-ssl=/usr/local/ssl \
--disable-dav \
--disable-asis \
--disable-vhost-alias \
--disable-imap \
--disable-userdir \
--enable-so

Same as 2.0.52 build which works

mod_perl configureperl Makefile.PL MP_AP_PREFIX=/usr/local/apache2 \
MP_CCOPTS=-DMP_IOBUFSIZE=16384 \
MP_COMPAT_1X=1 \
MP_USE_DSO=1 \
MP_INST_APACHE2=1

with 2.0.0rc4 as source. Same source with 2.0.52.

model prefork exhibits the problem as well.

cache settings:

CacheEnable mem /gifs     # works - if /fixed is added which has small
non-changing frame files, their information gets trashed. All are under the 8k
object size. The gifs directory seems immune.

MCacheSize 4096
MCacheMaxObjectCount 100
MCacheMinObjectSize 1
MCacheMaxObjectSize 8192

AddOutputFilter DEFLATE html htm would apply to the files having problems.

The work box has a different configuration, although it is also FC3, but it does
have the same cache/deflate operations.

If you need more information let me know.
Comment 3 William H. Haller 2005-04-20 04:54:15 UTC
Problem still exists with 2.0.54, mod_perl 2.0.0 rc5, php 5.0.4.
Comment 4 Paul Querna 2005-06-03 00:12:56 UTC
Can you please try mod_disk_cache?  Does it work correctly for you?
Comment 5 William H. Haller 2005-06-04 20:00:26 UTC
Is the mod_disk_cache suggested as an alternative or to give more info in
solving the problem? I have felt that memory caching - if implemented well -
would be a boost since Apache wouldn't have to interact with the O/S as much. If
it has to interact with the O/S, I've felt that the O/S was probably better at
managing a cache than an Apache add on. I'm willing to experiment with the
change to solve the problem, but won't try it as an alternative if that is what
is being suggested.
Comment 6 Paul Querna 2005-06-04 20:40:07 UTC
mod_disk_cache is better supported, and in general, has better performance,
since on most operating systems, it can use sendfile() and avoid copying data.
Comment 7 William H. Haller 2005-06-04 21:05:53 UTC
The configure file indicates sendfile is on by default if supported on the host
O/S and can be turned off for NFS mounts.
Comment 8 William A. Rowe Jr. 2018-11-07 21:09:00 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.